module Main where

import HFANN

-- Nodes definition for an ANN 
--    Input layer (4 neurons)
--    Hidden layer (8 neurons)
--    Output layer (1 neuron)
                              
fannDef :: [Int]
fannDef = [16,32, 1]

main :: IO ()
main = do
 
  -- Create a new ANN
  withStandardFann fannDef $ \fann -> do

    -- Replace the default activation function 'fannSigmoid' with
    -- a symmetric one

    setActivationFunctionHidden fann activationGaussianSymmetric
    setActivationFunctionOutput fann activationGaussianSymmetric

    --setActivationFunctionHidden fann activationLinear
    --setActivationFunctionOutput fann activationLinear

    --setActivationFunctionOutput fann activationSigmoidSymmetric
    --setActivationFunctionHidden fann activationSigmoidSymmetric

    setLearningRate fann 0.5
    setLearningMomentum fann 0.7

    --    tData <- loadTrainData "scaled_train.data"
    tData <- loadTrainData "scaled_zoo.data"
    --shuffleTrainData tData
            -- shuffleTrainData
    len <- trainDataLength tData
    putStrLn $ "len-> " ++ show len

    -- Do the training (and give reports)

    --          network  training data  epocs to run  reporting freq  desired error
    trainOnData  fann       tData           2000           100           0.00001

    -- Save the trained ANN (weights)
    saveFann fann "zoo.ann"

    putStrLn "Done ..\n"
